Imports NationalInstruments.VisaNS

Public Class Form1

    Private Sub Label1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        REM  ##############################################
        REM  
        REM    M3500A scanner card measure example
        REM
        REM    Using NI-VISA Visual Studio 2005 dotnet NationalInstruments.VisaNS
        REM
        REM  ##############################################

        Dim resources() As String
        Dim workrs As String
        Dim readary(10) As String
        Dim s As String
        Dim sw As Boolean
        Dim cnt As Integer
        Dim i As Integer
        Dim pos As Integer
        Dim dataGridViewRow As DataGridViewRow

        '
        ' Clear the DataGridView
        '
        Do While Me.DataGridView1.Rows.Count > 1
            With Me.DataGridView1.Rows
                DataGridViewRow = Me.DataGridView1.Rows(0)
                .Remove(DataGridViewRow)
            End With
        Loop

        Dim sm As NationalInstruments.VisaNS.MessageBasedSession
        Dim responseString As String

        '
        ' Check the Resource Manager all the resources
        ' find the M3500A device for "USB0::0x164E::0x0DAD"
        '
        resources = ResourceManager.GetLocalManager().FindResources("?*")
        sw = True
        For Each s In resources
            If s.Contains("0x164E::0x0DAD") Then
                sw = False
                workrs = s
                Exit For
            End If
        Next

        If sw Then
            MsgBox("M3500A USB device not found.")
            Exit Sub
        End If

        ' Set the working device -- open the session
        ' set the device to the initialize state -- *RST, *CLS
        '
        sm = ResourceManager.GetLocalManager().Open(workrs)
        sm.Write("*RST")
        sm.Write("*CLS")
        '
        ' Check the M3500A device scanner card plug-in ?
        '
        sm.Write("ROUT:STAT?")
        s = sm.ReadString
        If (s.Contains("1")) Then
            If Val(TextBox1.Text) > 2000 Then
                TextBox1.Text = 2000
            ElseIf Val(TextBox1.Text) <= 1 Then
                TextBox1.Text = 2
            End If
            cnt = Val(TextBox1.Text)
        Else
            '
            ' The scanner card not found.
            '
            MsgBox("Device Scanner card not found.", MsgBoxStyle.Exclamation, "M3500A Scanner card example")
            sm.Write("system:local")
            sm.Dispose()
            Exit Sub
        End If

        '
        ' Set the measurement function "Voltage DC" and the Auto range ON
        '
        sm.Write("CONF:VOLT:DC")
        sm.Write("SENS:VOLT:DC:RANG:AUTO ON")
        '
        ' Set the scan count and the delay time
        '
        sm.Write("ROUT:SCAN:COUNT " & TextBox1.Text)
        sm.Write("ROUT:SCAN:TIMER 0.2")
        '
        ' Set the channels ( 10 channels) function -- Voltage DC for all
        '
        For i = 1 To 10
            sm.Write("ROUT:SCAN:FUNC " & i.ToString & "," & Chr(34) & "VOLT:DC" & Chr(34))
        Next
        '
        ' Start the channels measurement and check the complete state
        '
        sm.Write("ROUT:SCAN")
        Do While (1)
            sm.Write("ROUT:SCAN:STAT?")
            Application.DoEvents()
            s = sm.ReadString()
            Label2.Text = CInt(s).ToString & " / " & TextBox1.Text
            If Val(s) >= Val(TextBox1.Text) Then
                Exit Do
            End If
        Loop

        '
        ' Fetch the measurement data and show the data in the DataGridView
        '
        Dim tom As Integer
        tom = sm.Timeout()
        sm.Timeout() = 20000
        sm.Write("FETCH?")
        cnt = cnt * 16
        responseString = sm.ReadString(32001)

        pos = 0
        Do While (pos < cnt)
            For i = 0 To 9
                readary(i) = ""
            Next
            For i = 0 To 9
                If (pos >= cnt) Then
                    Exit For
                End If
                readary(i) = responseString.Substring(pos, 15)
                pos = pos + 16
            Next
            Me.DataGridView1.Rows.Add(readary)
        Loop
        '
        ' Set the M3500A to local mode
        '
        sm.Timeout() = tom
        sm.Write("system:local")
        sm.Dispose()
        MsgBox("End of Job.", MsgBoxStyle.Information, "M3500A Scanner card example")

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        End
    End Sub
End Class
